org.apache.poi.hssf.record

## Class RecordFactory

- java.lang.Object
- - org.apache.poi.hssf.record.RecordFactory

-     public final class RecordFactory
      extends java.lang.Object

  Title: Record Factory

  Description: Takes a stream and outputs an array of Record objects.

  See Also:
    `EventRecordFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RecordFactory()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static BlankRecord[]` | `convertBlankRecords(MulBlankRecord mbk)` Converts a `MulBlankRecord` into an equivalent array of `BlankRecords`
    `static NumberRecord[]` | `convertRKRecords(MulRKRecord mrk)` Converts a `MulRKRecord` into an equivalent array of `NumberRecords`
    `static NumberRecord` | `convertToNumberRecord(RKRecord rk)` RK record is a slightly smaller alternative to NumberRecord POI likes NumberRecord better
    `static Record[]` | `createRecord(RecordInputStream in)` create a record, if there are MUL records than multiple records are returned digested into the non-mul form.
    `static java.util.List<Record>` | `createRecords(java.io.InputStream in)` Create an array of records from an input stream
    `static Record` | `createSingleRecord(RecordInputStream in)`
    `static short[]` | `getAllKnownRecordSIDs()`
    `static java.lang.Class<? extends Record>` | `getRecordClass(int sid)` Debug / diagnosis method

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RecordFactory

          public RecordFactory()

  - ### Method Detail

    - #### getRecordClass

          public static java.lang.Class<? extends Record> getRecordClass(int sid)

      Debug / diagnosis method

      Gets the POI implementation class for a given `sid`. Only a subset of the BIFF records are actually interpreted by POI. A few others are known but not interpreted (see `UnknownRecord.getBiffName(int)`).

      Parameters:
        `sid` - the record sid
      Returns:
        the POI implementation class for the specified record `sid`. `null` if the specified record is not interpreted by POI.

    - #### createRecord

          public static Record[] createRecord(RecordInputStream in)

      create a record, if there are MUL records than multiple records are returned digested into the non-mul form.
      Parameters:
        `in` - the RecordInputStream to read from
      Returns:
        the extracted records

    - #### createSingleRecord

          public static Record createSingleRecord(RecordInputStream in)

    - #### convertToNumberRecord

          public static NumberRecord convertToNumberRecord(RKRecord rk)

      RK record is a slightly smaller alternative to NumberRecord POI likes NumberRecord better
      Parameters:
        `rk` - the RK record to convert
      Returns:
        the NumberRecord

    - #### convertRKRecords

          public static NumberRecord[] convertRKRecords(MulRKRecord mrk)

      Converts a `MulRKRecord` into an equivalent array of `NumberRecords`
      Parameters:
        `mrk` - the MulRKRecord to convert
      Returns:
        the equivalent array of `NumberRecords`

    - #### convertBlankRecords

          public static BlankRecord[] convertBlankRecords(MulBlankRecord mbk)

      Converts a `MulBlankRecord` into an equivalent array of `BlankRecords`
      Parameters:
        `mbk` - the MulBlankRecord to convert
      Returns:
        the equivalent array of `BlankRecords`

    - #### getAllKnownRecordSIDs

          public static short[] getAllKnownRecordSIDs()

      Returns:
        an array of all the SIDS for all known records

    - #### createRecords

          public static java.util.List<Record> createRecords(java.io.InputStream in)
                                                      throws RecordFormatException

      Create an array of records from an input stream
      Parameters:
        `in` - the InputStream from which the records will be obtained
      Returns:
        an array of Records created from the InputStream
      Throws:
        `RecordFormatException` - on error processing the InputStream

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.